#if !defined (SCANNER_H)
#define SCANNER_H


#include <list>

using namespace std;

#include "trie.h"
#include "buffer.h"

class Scanner
{
private:	
	list<Pattern>	m_Patterns;
	size_t			shortest_sig;
	size_t			longest_sig;
	void Add( const string &name, const string &sig);
	Trie			m_Trie;
public:
	Scanner();
	Scanner( istream &in );
	~Scanner();
	void LoadDatabase(istream &in);
	bool Find(BlockBuffer *b, list<const Pattern*> **patterns);
	void Reset() { m_Trie.Reset(); }
	unsigned long GetDuplicates() const { return m_Trie.GetDuplicates(); }
};

#endif /* !defined (SCANNER_H) */